org.eclipse.cdt.core.dom.ast

## Interface IASTArraySubscriptExpression

All Superinterfaces:
  IASTExpression, IASTInitializerClause, IASTNode

All Known Subinterfaces:
  ICPPASTArraySubscriptExpression

    public interface IASTArraySubscriptExpression
    extends IASTExpression

This interface represents a postfix array subscript expression. x[10] y.z()[t * t]

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

### Field Summary

Fields
`static ASTNodeProperty` `ARRAY`
`static ASTNodeProperty` `SUBSCRIPT`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`IASTArraySubscriptExpression` `copy()` Returns a mutable copy of the tree rooted at this node.
`IASTArraySubscriptExpression` `copy(IASTNode.CopyStyle style)` Returns a mutable copy of the tree rooted at this node.
`IASTInitializerClause` `getArgument()` Returns the operand of this expression.
`IASTExpression` `getArrayExpression()` Get the expression that represents the array
`IASTExpression` `getSubscriptExpression()` Deprecated. Replaced by `getArgument()`
`void` `setArgument(IASTInitializerClause expression)` Not allowed on frozen ast.
`void` `setArrayExpression(IASTExpression expression)` Set the expression that represents the array.
`void` `setSubscriptExpression(IASTExpression expression)` Deprecated. Replaced by `setArgument(IASTInitializerClause)`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Field Detail

#### ARRAY

    static final ASTNodeProperty ARRAY

#### SUBSCRIPT

    static final ASTNodeProperty SUBSCRIPT

### Method Detail

#### getArrayExpression

    IASTExpression getArrayExpression()

Get the expression that represents the array

Returns:
  `IASTExpression` that represents the array.

#### setArrayExpression

    void setArrayExpression(IASTExpression expression)

Set the expression that represents the array.

Parameters:
  `expression` - `IASTExpression` to be set.

#### getArgument

    IASTInitializerClause getArgument()

Returns the operand of this expression. In c++ the operand can be a braced initializer list.

Since:
  5.2

#### setArgument

    void setArgument(IASTInitializerClause expression)

Not allowed on frozen ast.

Since:
  5.2

#### getSubscriptExpression

    @Deprecated
    IASTExpression getSubscriptExpression()

Deprecated. Replaced by `getArgument()`

Restriction:
  This method is not intended to be referenced by clients.

#### setSubscriptExpression

    @Deprecated
    void setSubscriptExpression(IASTExpression expression)

Deprecated. Replaced by `setArgument(IASTInitializerClause)`

Restriction:
  This method is not intended to be referenced by clients.

#### copy

    IASTArraySubscriptExpression copy()

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

#### copy

    IASTArraySubscriptExpression copy(IASTNode.CopyStyle style)

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3